﻿using Infragistics.Controls.Maps;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamMapGeoJSONCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            string coordinates;

            using(StreamReader stream = new StreamReader("../../MapData.json"))
            {
                string json = stream.ReadToEnd();
                dynamic array = JsonConvert.DeserializeObject(json);
                var geo = array.geometry;
                coordinates = geo.coordinates.ToString();
                stream.Close();
            }

            string[] coordSplit = coordinates.Split('[');

            List<Point> points = new List<Point>();

            foreach(string str in coordSplit)
            {
                string[] pointSplit = str.Split(',');

                if(pointSplit.Length >= 4)
                {
                    double xVal = 0;
                    double yVal = 0;
                    double.TryParse(pointSplit[0], out xVal);
                    double.TryParse(pointSplit[1], out yVal);

                    points.Add(new Point(xVal, yVal));
                }
            }

            List<MyDataItem> data = new List<MyDataItem>();
            data.Add(new MyDataItem() { Points = points });

            GeographicShapeSeries series = new GeographicShapeSeries()
            {
                ItemsSource = data,
                ShapeMemberPath = "Points",
                Brush = Brushes.Purple,
                Outline = Brushes.Black
            };
                       
            map.Series.Add(series);

            Rect windowRect = new Rect(0.516950475667115, 0.312068278205195, 0.00148689035874272, 0.00148689035874272);
            map.WindowRect = windowRect;
        }        
    }

    public class MyDataItem
    {
        public List<Point> Points { get; set; }
    }
}
